var form_slider_handle = '/apps/lvm/images/slider_handle.gif';
var slider_handle_image_obj = false;
var sliderObjectArray = new Array();
var slider_counter = 0;
var slideInProgress = false;
var handle_start_x;
var event_start_x;
var currentSliderIndex;
var sliderHandleWidth = 9;

function form_widget_cancel_event()
{
	return false;		
}

function getImageSliderHeight(){
	if(!slider_handle_image_obj){
		slider_handle_image_obj = new Image();
		slider_handle_image_obj.src = form_slider_handle;
	}
	if(slider_handle_image_obj.width>0){
		return;
	}else{
		setTimeout('getImageSliderHeight()',50);
	}
}

function positionSliderImage(e,theIndex)
{
	
	if(!theIndex)theIndex = this.getAttribute('sliderIndex');
	var theValue = sliderObjectArray[theIndex]['formTarget'].value;
	if(!theValue.match(/^[0-9]*$/g))theValue=sliderObjectArray[theIndex]['min'] +'';
	if(theValue/1>sliderObjectArray[theIndex]['max'])theValue = sliderObjectArray[theIndex]['max'];
	if(theValue/1<sliderObjectArray[theIndex]['min'])theValue = sliderObjectArray[theIndex]['min'];
	sliderObjectArray[theIndex]['formTarget'].value = theValue;
	var handleImg = document.getElementById('slider_handle' + theIndex);
	var ratio = sliderObjectArray[theIndex]['width'] / (sliderObjectArray[theIndex]['max']-sliderObjectArray[theIndex]['min']);
	var currentValue = sliderObjectArray[theIndex]['formTarget'].value-sliderObjectArray[theIndex]['min'];		
	handleImg.style.left = Math.round(currentValue * ratio) + 'px';	
}

function adjustFormValue(theIndex)
{
	var handleImg = document.getElementById('slider_handle' + theIndex);	
	var ratio = sliderObjectArray[theIndex]['width'] / (sliderObjectArray[theIndex]['max']-sliderObjectArray[theIndex]['min']);
	var currentPos = handleImg.style.left.replace('px','');
	sliderObjectArray[theIndex]['formTarget'].value = Math.round(currentPos / ratio) + sliderObjectArray[theIndex]['min'];
	
}
	
function initMoveSlider(e)
{

	if(document.all)e = event;	
	slideInProgress = true;
	event_start_x = e.clientX;
	handle_start_x = this.style.left.replace('px','');
	currentSliderIndex = this.id.replace(/[^\d]/g,'');
	return false;
}

function startMoveSlider(e)
{
	if(document.all)e = event;	
	if(!slideInProgress)return;	
	var leftPos = handle_start_x/1 + e.clientX/1 - event_start_x;
	if(leftPos<0)leftPos = 0;
	if(leftPos/1>sliderObjectArray[currentSliderIndex]['width'])leftPos = sliderObjectArray[currentSliderIndex]['width'];
	document.getElementById('slider_handle' + currentSliderIndex).style.left = leftPos + 'px';
	adjustFormValue(currentSliderIndex);
	if(sliderObjectArray[currentSliderIndex]){
		eval(sliderObjectArray[currentSliderIndex]);
	}
}

function stopMoveSlider()
{
	slideInProgress = false;
}

function form_slider(targetElId,formTarget,width,min,max,num)
{
	if(!slider_handle_image_obj){
		getImageSliderHeight();		
	}
	
	if(num == "0"){
		slider_counter = num +1; 
	}else{
		slider_counter = slider_counter +1;
	}
	sliderObjectArray[slider_counter] = new Array();
	sliderObjectArray[slider_counter] = {"width":width - sliderHandleWidth,"min":min,"max":max,"formTarget":formTarget};
	
	formTarget.setAttribute('sliderIndex',slider_counter);
	formTarget.onchange = positionSliderImage;
	var parentObj = document.createElement('DIV');
	
	parentObj.style.height = '12px';	// The height of the image
	parentObj.style.position = 'relative';
	parentObj.id = 'slider_container' + slider_counter;
	document.getElementById(targetElId).appendChild(parentObj);
	
	var obj = document.createElement('DIV');
	obj.className = 'form_slider';
	obj.innerHTML = '<span></span>';
	obj.style.width = width + 'px';
	obj.id = 'slider_slider' + slider_counter;
	obj.style.position = 'absolute';
	obj.style.bottom = '0px';
	parentObj.appendChild(obj);
	
	var handleImg = document.createElement('IMG');
	handleImg.style.position = 'absolute';
	handleImg.style.left = '0px';
	handleImg.style.zIndex = 5;
	handleImg.src = slider_handle_image_obj.src;
	handleImg.id = 'slider_handle' + slider_counter;
	handleImg.onmousedown = initMoveSlider;
	
	parentObj.style.width = obj.offsetWidth + 'px';
		document.body.onmouseup = stopMoveSlider;
		document.body.onmousemove = startMoveSlider;

	handleImg.ondragstart = form_widget_cancel_event;
	parentObj.appendChild(handleImg);
	positionSliderImage(false,slider_counter);
}

function defineOwnScroll(id,id2){
	var obj=document.getElementById(id);
	var list=document.getElementById(id2);
	list.scrollTop=0;
	var oUl=list.children[0];
	var bar=obj.getElementsByTagName("div")[0];
	//alert(oUl.offsetHeight)
	//alert(list.offsetHeight)
	if(oUl.offsetHeight>list.offsetHeight){//如果子元素的高度大于父元素的高度，那么滚动条出现
		obj.style.display='block';
		list.style.overflowY='scroll';
		//按比例设置滚动条长度
		bar.style.height=Math.floor(list.offsetHeight*list.offsetHeight/oUl.offsetHeight)+'px';
		// alert(bar.style.height)
		bar.style.overflow='hidden';
		//拖拽滚动条事件加载
		bar.onmousedown=function(ev){
			var o=this;
			var oEvent=ev||event;  //兼容
			var y=oEvent.clientY-this.offsetTop;
			document.onmousemove=function(ev){
				oEvent=ev||event;
				var otop=oEvent.clientY-y;
				var stop=otop*oUl.offsetHeight/obj.offsetHeight;
				if(otop<=0){
					o.style.top=0+'px';
					list.scrollTop=0;
				}else if(otop>=obj.offsetHeight-bar.offsetHeight){
					o.style.top=obj.offsetHeight-bar.offsetHeight+'px';
					list.scrollTop=oUl.offsetHeight-list.offsetHeight;
				}else{
					o.style.top=otop+'px';
					list.scrollTop=stop;
				}
			}
			document.onmouseup=function(){
				document.onmousemove=null;
				document.onmouseup=null;
			}
		}
	
		//鼠标滚轮事件加载
		list.onscroll=function(){
			bar.style.top=list.scrollTop*obj.offsetHeight/oUl.offsetHeight+'px';
		}
	}
}
